/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.145
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.76 2007/05/09 16:25:33 cardoe Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.145 2010/04/27 05:45:55 robbat2 Exp $
4 4
5# @ECLASS: mysql.eclass
6# @MAINTAINER:
5# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
6# Maintainer: Luca Longinotti <chtekk@gentoo.org> 9# - Luca Longinotti <chtekk@gentoo.org>
7 10# - Robin H. Johnson <robbat2@gentoo.org>
8# Both MYSQL_VERSION_ID and MYSQL_PATCHSET_REV must be set in the ebuild too! 11# @BLURB: This eclass provides most of the functions for mysql ebuilds
9# Note that MYSQL_VERSION_ID must be empty! 12# @DESCRIPTION:
13# The mysql.eclass provides almost all the code to build the mysql ebuilds
14# including the src_unpack, src_prepare, src_configure, src_compile,
15# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
16# phase hooks.
10 17
11WANT_AUTOCONF="latest" 18WANT_AUTOCONF="latest"
12WANT_AUTOMAKE="latest" 19WANT_AUTOMAKE="latest"
13 20
14inherit eutils flag-o-matic gnuconfig autotools mysql_fx 21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator toolchain-funcs
15 22
16# Shorten the path because the socket path length must be shorter than 107 chars 23# Shorten the path because the socket path length must be shorter than 107 chars
17# and we will run a mysql server during test phase 24# and we will run a mysql server during test phase
18S="${WORKDIR}/mysql" 25S="${WORKDIR}/mysql"
19 26
20[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108" 27[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
21 28if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
22if [[ ${PR#r} -lt 60 ]] ; then 29 EGIT_PROJECT=mysql-extras
23 IS_BITKEEPER=0 30 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
24elif [[ ${PR#r} -lt 90 ]] ; then 31 inherit git
25 IS_BITKEEPER=60
26else
27 IS_BITKEEPER=90
28fi 32fi
29 33
34case "${EAPI:-0}" in
35 2)
36 EXPORT_FUNCTIONS pkg_setup \
37 src_unpack src_prepare \
38 src_configure src_compile \
39 src_install \
40 pkg_preinst pkg_postinst \
41 pkg_config pkg_postrm
42 IUSE_DEFAULT_ON='+'
43 ;;
44 0 | 1)
45 EXPORT_FUNCTIONS pkg_setup \
46 src_unpack \
47 src_compile \
48 src_install \
49 pkg_preinst pkg_postinst \
50 pkg_config pkg_postrm
51 ;;
52 *)
53 die "Unsupported EAPI: ${EAPI}" ;;
54esac
55
56
57# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
58# @DESCRIPTION:
59# Upstream MySQL considers the first two parts of the version number to be the
60# major version. Upgrades that change major version should always run
61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63
64# @ECLASS-VARIABLE: MYSQL_VERSION_ID
65# @DESCRIPTION:
30# MYSQL_VERSION_ID will be: 66# MYSQL_VERSION_ID will be:
31# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 67# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
32# This is an important part, because many of the choices the MySQL ebuild will do 68# This is an important part, because many of the choices the MySQL ebuild will do
33# depend on this variable. 69# depend on this variable.
34# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 70# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
71# We also strip off upstream's trailing letter that they use to respin tarballs
35 72
36MYSQL_VERSION_ID="" 73MYSQL_VERSION_ID=""
74tpv="${PV%[a-z]}"
37tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 75tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
38for vatom in 0 1 2 3 ; do 76for vatom in 0 1 2 3 ; do
39 # pad to length 2 77 # pad to length 2
40 tpv[${vatom}]="00${tpv[${vatom}]}" 78 tpv[${vatom}]="00${tpv[${vatom}]}"
41 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 79 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
42done 80done
43# strip leading "0" (otherwise it's considered an octal number by BASH) 81# strip leading "0" (otherwise it's considered an octal number by BASH)
44MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 82MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
45 83
84# @ECLASS-VARIABLE: MYSQL_COMMUNITY_FEATURES
85# @DESCRIPTION:
86# Specifiy if community features are available. Possible values are 1 (yes)
87# and 0 (no).
88# Community features are available in mysql-community
89# AND in the re-merged mysql-5.0.82 and newer
90if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
91 MYSQL_COMMUNITY_FEATURES=1
92elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
93 MYSQL_COMMUNITY_FEATURES=1
94elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
95 MYSQL_COMMUNITY_FEATURES=1
96elif [ "${PV#5.4}" != "${PV}" ] ; then
97 MYSQL_COMMUNITY_FEATURES=1
98elif [ "${PV#5.5}" != "${PV}" ] ; then
99 MYSQL_COMMUNITY_FEATURES=1
100elif [ "${PV#6.0}" != "${PV}" ] ; then
101 MYSQL_COMMUNITY_FEATURES=1
102else
103 MYSQL_COMMUNITY_FEATURES=0
104fi
105
106# @ECLASS-VARIABLE: XTRADB_VER
107# @DESCRIPTION:
108# Version of the XTRADB storage engine
109XTRADB_VER="${XTRADB_VER}"
110
111# @ECLASS-VARIABLE: PERCONA_VER
112# @DESCRIPTION:
113# Designation by PERCONA for a MySQL version to apply an XTRADB release
114PERCONA_VER="${PERCONA_VER}"
115
46# Be warned, *DEPEND are version-dependant 116# Be warned, *DEPEND are version-dependant
117# These are used for both runtime and compiletime
47DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 118DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
48 userland_GNU? ( sys-process/procps ) 119 userland_GNU? ( sys-process/procps )
49 >=sys-apps/sed-4 120 >=sys-apps/sed-4
50 >=sys-apps/texinfo-4.7-r1 121 >=sys-apps/texinfo-4.7-r1
51 >=sys-libs/readline-4.1 122 >=sys-libs/readline-4.1
52 >=sys-libs/zlib-1.2.3" 123 >=sys-libs/zlib-1.2.3"
53 124
125[[ "${PN}" == "mariadb" ]] \
126&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
127
54# Having different flavours at the same time is not a good idea 128# Having different flavours at the same time is not a good idea
55for i in "" "-community" ; do 129for i in "mysql" "mysql-community" "mariadb" ; do
56 [[ "${i}" == ${PN#mysql} ]] || 130 [[ "${i}" == ${PN} ]] ||
57 DEPEND="${DEPEND} !dev-db/mysql${i}" 131 DEPEND="${DEPEND} !dev-db/${i}"
58done 132done
59
60mysql_version_is_at_least "5.1" \
61|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
62
63mysql_version_is_at_least "5.1.12" \
64&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
65
66# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
67PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
68
69# BitKeeper dependency, compile-time only
70[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
71
72# Define correct SRC_URIs
73SRC_URI="${SERVER_URI}
74 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
75 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
76mysql_version_is_at_least "5.1.12" \
77&& [[ -n "${PBXT_VERSION}" ]] \
78&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
79
80DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
81HOMEPAGE="http://www.mysql.com/"
82LICENSE="GPL-2"
83SLOT="0"
84IUSE="big-tables debug embedded minimal perl selinux ssl static"
85RESTRICT="confcache"
86
87mysql_version_is_at_least "4.1" \
88&& IUSE="${IUSE} latin1"
89
90mysql_version_is_at_least "4.1.3" \
91&& IUSE="${IUSE} cluster extraengine"
92
93mysql_version_is_at_least "5.0" \
94|| IUSE="${IUSE} raid"
95
96mysql_version_is_at_least "5.0.18" \
97&& IUSE="${IUSE} max-idx-128"
98
99mysql_version_is_at_least "5.1" \
100&& IUSE="${IUSE} innodb"
101
102mysql_version_is_at_least "5.1" \
103|| IUSE="${IUSE} berkdb"
104
105mysql_version_is_at_least "5.1.12" \
106&& IUSE="${IUSE} pbxt"
107 133
108RDEPEND="${DEPEND} 134RDEPEND="${DEPEND}
109 !minimal? ( dev-db/mysql-init-scripts ) 135 !minimal? ( dev-db/mysql-init-scripts )
110 selinux? ( sec-policy/selinux-mysql )" 136 selinux? ( sec-policy/selinux-mysql )"
111 137
112EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 138# compile-time-only
113 pkg_postinst pkg_config pkg_postrm 139mysql_version_is_at_least "5.1" \
140|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
141
142# compile-time-only
143mysql_version_is_at_least "5.1.12" \
144&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
145
146# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
147PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
148
149# For other stuff to bring us in
150PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
151
152# Work out the default SERVER_URI correctly
153if [ -z "${SERVER_URI}" ]; then
154 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
155 if [ "${PN}" == "mariadb" ]; then
156 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
157 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
158 SERVER_URI="
159 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
160 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
161 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
162 "
163 # The community build is on the mirrors
164 elif [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
165 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz"
166 # The (old) enterprise source is on the primary site only
167 elif [ "${PN}" == "mysql" ]; then
168 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
169 fi
170fi
171
172# Define correct SRC_URIs
173SRC_URI="${SERVER_URI}"
174
175# Gentoo patches to MySQL
176[[ ${MY_EXTRAS_VER} != live ]] \
177&& SRC_URI="${SRC_URI}
178 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
179 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
180 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
181
182DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
183HOMEPAGE="http://www.mysql.com/"
184if [[ "${PN}" == "mariadb" ]]; then
185 HOMEPAGE="http://askmonty.org/"
186 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
187fi
188if [[ "${PN}" == "mysql-community" ]]; then
189 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
190fi
191LICENSE="GPL-2"
192SLOT="0"
193IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
194
195mysql_version_is_at_least "4.1" \
196&& IUSE="${IUSE} latin1"
197
198mysql_version_is_at_least "4.1.3" \
199&& IUSE="${IUSE} cluster extraengine"
200
201mysql_version_is_at_least "5.0" \
202|| IUSE="${IUSE} raid"
203
204mysql_version_is_at_least "5.0.18" \
205&& IUSE="${IUSE} max-idx-128"
206
207mysql_version_is_at_least "5.1" \
208|| IUSE="${IUSE} berkdb"
209
210[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
211&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
212
213[[ "${PN}" == "mariadb" ]] \
214&& IUSE="${IUSE} libevent"
215
216# MariaDB has integrated PBXT
217# PBXT_VERSION means that we have a PBXT patch for this PV
218# PBXT was only introduced after 5.1.12
219pbxt_patch_available() {
220 [[ "${PN}" != "mariadb" ]] \
221 && mysql_version_is_at_least "5.1.12" \
222 && [[ -n "${PBXT_VERSION}" ]]
223 return $?
224}
225
226pbxt_available() {
227 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
228 return $?
229}
230
231# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
232# MariaDB has integrated XtraDB
233# XTRADB_VERS means that we have a XTRADB patch for this PV
234# XTRADB was only introduced after 5.1.26
235xtradb_patch_available() {
236 [[ "${PN}" != "mariadb" ]] \
237 && mysql_version_is_at_least "5.1.26" \
238 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
239 return $?
240}
241
242
243pbxt_patch_available \
244&& PBXT_P="pbxt-${PBXT_VERSION}" \
245&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
246&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
247
248# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
249# vs. built outside the dir
250pbxt_available \
251&& IUSE="${IUSE} pbxt" \
252&& mysql_version_is_at_least "5.1.40" \
253&& PBXT_NEWSTYLE=1
254
255xtradb_patch_available \
256&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
257&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
258&& XTRADB_SRC_B1="http://www.percona.com/" \
259&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
260&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
261&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
262&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
263&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
264&& IUSE="${IUSE} xtradb"
114 265
115# 266#
116# HELPER FUNCTIONS: 267# HELPER FUNCTIONS:
117# 268#
118 269
119bitkeeper_fetch() { 270# @FUNCTION: mysql_disable_test
120 local reposuf 271# @DESCRIPTION:
121 if [[ -z "${1}" ]] ; then 272# Helper function to disable specific tests.
122 local tpv
123 tpv=( ${PV//[-._]/ } )
124 reposuf="mysql-${tpv[0]}.${tpv[1]}"
125 else
126 reposuf="${1}"
127 fi
128 einfo "Using '${reposuf}' repository."
129 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
130 ## -- ebk_store_dir: bitkeeper sources store directory
131 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
132 ## -- ebk_fetch_cmd: bitkeeper fetch command
133 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
134 # hint: does not work
135 local ebk_fetch_cmd="sfioball"
136 ## -- ebk_update_cmd: bitkeeper update command
137 local ebk_update_cmd="update"
138
139 # addread "/etc/bitkeeper"
140 addwrite "${ebk_store_dir}"
141
142 if [[ ! -d "${ebk_store_dir}" ]] ; then
143 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
144 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
145 fi
146
147 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
148
149 local wc_path=${reposuf}
150
151 if [[ ! -d "${wc_path}" ]] ; then
152 local options="-r+"
153
154 # first checkout
155 einfo "bitkeeper checkout start -->"
156 einfo " repository: ${repo_uri}"
157
158 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
159 || die "BK: couldn't fetch from ${repo_uri}"
160 else
161 if [[ ! -d "${wc_path}/BK" ]] ; then
162 popd
163 die "Looks like ${wc_path} is not a bitkeeper path"
164 fi
165
166 # update working copy
167 einfo "bitkeeper update start -->"
168 einfo " repository: ${repo_uri}"
169
170 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
171 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
172 fi
173
174 einfo " working copy: ${wc_path}"
175 cd "${wc_path}"
176 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
177
178 echo
179 popd
180}
181
182mysql_disable_test() { 273mysql_disable_test() {
274 local rawtestname testname testsuite reason mysql_disable_file
183 local testname="${1}" ; shift 275 rawtestname="${1}" ; shift
184 local reason="${@}" 276 reason="${@}"
277 ewarn "test '${rawtestname}' disabled: '${reason}'"
278
279 testsuite="${rawtestname/.*}"
280 testname="${rawtestname/*.}"
185 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 281 mysql_disable_file="${S}/mysql-test/t/disabled.def"
282 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
186 echo ${testname} : ${reason} >> "${mysql_disable_file}" 283 echo ${testname} : ${reason} >> "${mysql_disable_file}"
187 ewarn "test '${testname}' disabled: '${reason}'"
188}
189 284
285 # ${S}/mysql-tests/t/disabled.def
286 #
287 # ${S}/mysql-tests/suite/federated/disabled.def
288 #
289 # ${S}/mysql-tests/suite/jp/t/disabled.def
290 # ${S}/mysql-tests/suite/ndb/t/disabled.def
291 # ${S}/mysql-tests/suite/rpl/t/disabled.def
292 # ${S}/mysql-tests/suite/parts/t/disabled.def
293 # ${S}/mysql-tests/suite/rpl_ndb/t/disabled.def
294 # ${S}/mysql-tests/suite/ndb_team/t/disabled.def
295 # ${S}/mysql-tests/suite/binlog/t/disabled.def
296 # ${S}/mysql-tests/suite/innodb/t/disabled.def
297 if [ -n "${testsuite}" ]; then
298 for mysql_disable_file in \
299 ${S}/mysql-test/suite/${testsuite}/disabled.def \
300 ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
301 FAILED ; do
302 [ -f "${mysql_disable_file}" ] && break
303 done
304 if [ "${mysql_disabled_file}" != "FAILED" ]; then
305 echo "${testname} : ${reason}" >> "${mysql_disable_file}"
306 else
307 ewarn "Could not find testsuite disabled.def location for ${rawtestname}"
308 fi
309 fi
310}
311
312# @FUNCTION: mysql_init_vars
313# @DESCRIPTION:
190# void mysql_init_vars() 314# void mysql_init_vars()
191#
192# Initialize global variables 315# Initialize global variables
193# 2005-11-19 <vivo@gentoo.org> 316# 2005-11-19 <vivo@gentoo.org>
194
195mysql_init_vars() { 317mysql_init_vars() {
196 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"} 318 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
197 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"} 319 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
198 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"} 320 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
199 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"} 321 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
206 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \ 328 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
207 | sed -ne '/datadir/s|^--datadir=||p' \ 329 | sed -ne '/datadir/s|^--datadir=||p' \
208 | tail -n1` 330 | tail -n1`
209 if [[ -z "${MY_DATADIR}" ]] ; then 331 if [[ -z "${MY_DATADIR}" ]] ; then
210 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 332 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
211 | sed -e 's/.*=\s*//'` 333 | sed -e 's/.*=\s*//' \
334 | tail -n1`
212 fi 335 fi
213 fi 336 fi
214 if [[ -z "${MY_DATADIR}" ]] ; then 337 if [[ -z "${MY_DATADIR}" ]] ; then
215 MY_DATADIR="${MY_LOCALSTATEDIR}" 338 MY_DATADIR="${MY_LOCALSTATEDIR}"
216 einfo "Using default MY_DATADIR" 339 einfo "Using default MY_DATADIR"
217 fi 340 fi
218 elog "MySQL MY_DATADIR is ${MY_DATADIR}" 341 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
219 342
220 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 343 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
221 if [[ -e "${MY_DATADIR}" ]] ; then 344 if [[ -e "${MY_DATADIR}" ]] ; then
222 elog "Previous datadir found, it's YOUR job to change" 345 # If you get this and you're wondering about it, see bug #207636
223 elog "ownership and take care of it" 346 elog "MySQL datadir found in ${MY_DATADIR}"
347 elog "A new one will not be created."
224 PREVIOUS_DATADIR="yes" 348 PREVIOUS_DATADIR="yes"
225 else 349 else
226 PREVIOUS_DATADIR="no" 350 PREVIOUS_DATADIR="no"
227 fi 351 fi
228 export PREVIOUS_DATADIR 352 export PREVIOUS_DATADIR
229 fi 353 fi
354 else
355 if [[ ${EBUILD_PHASE} == "config" ]]; then
356 local new_MY_DATADIR
357 new_MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
358 | sed -ne '/datadir/s|^--datadir=||p' \
359 | tail -n1`
360
361 if [[ ( -n "${new_MY_DATADIR}" ) && ( "${new_MY_DATADIR}" != "${MY_DATADIR}" ) ]]; then
362 ewarn "MySQL MY_DATADIR has changed"
363 ewarn "from ${MY_DATADIR}"
364 ewarn "to ${new_MY_DATADIR}"
365 MY_DATADIR="${new_MY_DATADIR}"
366 fi
367 fi
230 fi 368 fi
231 369
232 MY_SOURCEDIR=${SERVER_URI##*/} 370 MY_SOURCEDIR=${SERVER_URI##*/}
233 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 371 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
234 372
239 377
240configure_minimal() { 378configure_minimal() {
241 # These are things we exclude from a minimal build, please 379 # These are things we exclude from a minimal build, please
242 # note that the server actually does get built and installed, 380 # note that the server actually does get built and installed,
243 # but we then delete it before packaging. 381 # but we then delete it before packaging.
244 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 382 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
245 383
246 for i in ${minimal_exclude_list} ; do 384 for i in ${minimal_exclude_list} ; do
247 myconf="${myconf} --without-${i}" 385 myconf="${myconf} --without-${i}"
248 done 386 done
249 myconf="${myconf} --with-extra-charsets=none" 387 myconf="${myconf} --with-extra-charsets=none"
250 myconf="${myconf} --enable-local-infile" 388 myconf="${myconf} --enable-local-infile"
251 389
252 if use static ; then 390 if use static ; then
253 myconf="${myconf} --with-client-ldflags=-all-static" 391 myconf="${myconf} --with-client-ldflags=-all-static"
254 myconf="${myconf} --disable-shared" 392 myconf="${myconf} --disable-shared --with-pic"
255 else 393 else
256 myconf="${myconf} --enable-shared --enable-static" 394 myconf="${myconf} --enable-shared --enable-static"
257 fi 395 fi
258 396
259 if mysql_version_is_at_least "4.1" && ! use latin1 ; then 397 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
275 myconf="${myconf} --without-libwrap" 413 myconf="${myconf} --without-libwrap"
276 414
277 if use static ; then 415 if use static ; then
278 myconf="${myconf} --with-mysqld-ldflags=-all-static" 416 myconf="${myconf} --with-mysqld-ldflags=-all-static"
279 myconf="${myconf} --with-client-ldflags=-all-static" 417 myconf="${myconf} --with-client-ldflags=-all-static"
280 myconf="${myconf} --disable-shared" 418 myconf="${myconf} --disable-shared --with-pic"
281 else 419 else
282 myconf="${myconf} --enable-shared --enable-static" 420 myconf="${myconf} --enable-shared --enable-static"
283 fi 421 fi
284 422
285 if use debug ; then 423 if use debug ; then
289 mysql_version_is_at_least "4.1.3" \ 427 mysql_version_is_at_least "4.1.3" \
290 && use cluster \ 428 && use cluster \
291 && myconf="${myconf} --without-ndb-debug" 429 && myconf="${myconf} --without-ndb-debug"
292 fi 430 fi
293 431
432 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
433 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
434 ewarn "and a collation of ${MYSQL_DEFAULT_COLLATION}."
435 ewarn "You MUST file bugs without these variables set."
436 myconf="${myconf} --with-charset=${MYSQL_DEFAULT_CHARSET}"
437 myconf="${myconf} --with-collation=${MYSQL_DEFAULT_COLLATION}"
294 if mysql_version_is_at_least "4.1" && ! use latin1 ; then 438 elif mysql_version_is_at_least "4.1" && ! use latin1 ; then
295 myconf="${myconf} --with-charset=utf8" 439 myconf="${myconf} --with-charset=utf8"
296 myconf="${myconf} --with-collation=utf8_general_ci" 440 myconf="${myconf} --with-collation=utf8_general_ci"
297 else 441 else
298 myconf="${myconf} --with-charset=latin1" 442 myconf="${myconf} --with-charset=latin1"
299 myconf="${myconf} --with-collation=latin1_swedish_ci" 443 myconf="${myconf} --with-collation=latin1_swedish_ci"
300 fi 444 fi
301 445
302 if use embedded ; then 446 if use embedded ; then
303 myconf="${myconf} --with-embedded-privilege-control" 447 myconf="${myconf} --with-embedded-privilege-control"
304 myconf="${myconf} --with-embedded-server" 448 myconf="${myconf} --with-embedded-server"
313 myconf="${myconf} $(use_with perl bench)" 457 myconf="${myconf} $(use_with perl bench)"
314 myconf="${myconf} --enable-assembler" 458 myconf="${myconf} --enable-assembler"
315 myconf="${myconf} --with-extra-tools" 459 myconf="${myconf} --with-extra-tools"
316 myconf="${myconf} --with-innodb" 460 myconf="${myconf} --with-innodb"
317 myconf="${myconf} --without-readline" 461 myconf="${myconf} --without-readline"
462 myconf="${myconf} $(use_with ssl openssl)"
318 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 463 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
319 464
320 # --with-vio is not needed anymore, it's on by default and 465 # --with-vio is not needed anymore, it's on by default and
321 # has been removed from configure 466 # has been removed from configure
467 # Apply to 4.x and 5.0.[0-3]
322 if use ssl ; then 468 if use ssl ; then
323 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 469 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
324 fi 470 fi
325 471
326 if mysql_version_is_at_least "5.1.11" ; then 472 if mysql_version_is_at_least "5.0.60" ; then
327 myconf="${myconf} $(use_with ssl)"
328 else
329 myconf="${myconf} $(use_with ssl openssl)"
330 fi
331
332 if use berkdb ; then 473 if use berkdb ; then
474 elog "Berkeley DB support was disabled due to build failures"
475 elog "on multiple arches, go to a version earlier than 5.0.60"
476 elog "if you want it again. Gentoo bug #224067."
477 fi
478 myconf="${myconf} --without-berkeley-db"
479 elif use berkdb ; then
333 # The following fix is due to a bug with bdb on SPARC's. See: 480 # The following fix is due to a bug with bdb on SPARC's. See:
334 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8 481 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
335 # It comes down to non-64-bit safety problems. 482 # It comes down to non-64-bit safety problems.
336 if use alpha || use amd64 || use hppa || use mips || use sparc ; then 483 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
337 elog "Berkeley DB support was disabled due to compatiblity issues on this arch" 484 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
338 myconf="${myconf} --without-berkeley-db" 485 myconf="${myconf} --without-berkeley-db"
339 else 486 else
340 myconf="${myconf} --with-berkeley-db=./bdb" 487 myconf="${myconf} --with-berkeley-db=./bdb"
341 fi 488 fi
342 else 489 else
366 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html" 513 elog "http://dev.mysql.com/doc/mysql/en/federated-limitations.html"
367 myconf="${myconf} --with-federated-storage-engine" 514 myconf="${myconf} --with-federated-storage-engine"
368 fi 515 fi
369 fi 516 fi
370 517
518 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
519 myconf="${myconf} `use_enable community community-features`"
520 if use community; then
521 myconf="${myconf} `use_enable profiling`"
522 else
523 myconf="${myconf} --disable-profiling"
524 fi
525 fi
526
371 mysql_version_is_at_least "5.0.18" \ 527 mysql_version_is_at_least "5.0.18" \
372 && use max-idx-128 \ 528 && use max-idx-128 \
373 && myconf="${myconf} --with-max-indexes=128" 529 && myconf="${myconf} --with-max-indexes=128"
374} 530}
375 531
376configure_51() { 532configure_51() {
377 # TODO: !!!! readd --without-readline 533 # TODO: !!!! readd --without-readline
378 # the failure depend upon config/ac-macros/readline.m4 checking into 534 # the failure depend upon config/ac-macros/readline.m4 checking into
379 # readline.h instead of history.h 535 # readline.h instead of history.h
380 myconf="${myconf} $(use_with ssl)" 536 myconf="${myconf} $(use_with ssl ssl /usr)"
381 myconf="${myconf} --enable-assembler" 537 myconf="${myconf} --enable-assembler"
382 myconf="${myconf} --with-geometry" 538 myconf="${myconf} --with-geometry"
383 myconf="${myconf} --with-readline" 539 myconf="${myconf} --with-readline"
384 myconf="${myconf} --with-row-based-replication"
385 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 540 myconf="${myconf} --with-zlib-dir=/usr/"
386 myconf="${myconf} --without-pstack" 541 myconf="${myconf} --without-pstack"
542 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
543
387 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 544 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
545 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
546 myconf="${myconf} $(use_enable community community-features)"
547 if use community; then
548 myconf="${myconf} $(use_enable profiling)"
549 else
550 myconf="${myconf} --disable-profiling"
551 fi
552 fi
553
554 # Scan for all available plugins
555 local plugins_avail="$(
556 LANG=C \
557 find "${S}" \
558 \( \
559 -name 'plug.in' \
560 -o -iname 'configure.in' \
561 -o -iname 'configure.ac' \
562 \) \
563 -print0 \
564 | xargs -0 sed -r -n \
565 -e '/^MYSQL_STORAGE_ENGINE/{
566 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
567 s~^([^ ]+).*~\1~gp;
568 }' \
569 | tr -s '\n' ' '
570 )"
388 571
389 # 5.1 introduces a new way to manage storage engines (plugins) 572 # 5.1 introduces a new way to manage storage engines (plugins)
390 # like configuration=none 573 # like configuration=none
574 # This base set are required, and will always be statically built.
391 local plugins="csv,myisam,myisammrg,heap" 575 local plugins_sta="csv myisam myisammrg heap"
576 local plugins_dyn=""
577 local plugins_dis="example ibmdb2i"
578
579 # These aren't actually required by the base set, but are really useful:
580 plugins_sta="${plugins_sta} archive blackhole"
581
582 # default in 5.5.4
583 if mysql_version_is_at_least "5.5.4" ; then
584 plugins_sta="${plugins_sta} partition"
585 fi
586 # Now the extras
392 if use extraengine ; then 587 if use extraengine ; then
393 # like configuration=max-no-ndb, archive and example removed in 5.1.11 588 # like configuration=max-no-ndb, archive and example removed in 5.1.11
394 plugins="${plugins},archive,blackhole,example,federated,partition" 589 # not added yet: ibmdb2i
590 # Not supporting as examples: example,daemon_example,ftexample
591 plugins_sta="${plugins_sta} partition"
592 plugins_dyn="${plugins_sta} federated"
395 593
594 if [[ "${PN}" != "mariadb" ]] ; then
396 elog "Before using the Federated storage engine, please be sure to read" 595 elog "Before using the Federated storage engine, please be sure to read"
397 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 596 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
597 else
598 elog "MariaDB includes the FederatedX engine. Be sure to read"
599 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
398 fi 600 fi
399 601 else
400 if use innodb ; then 602 plugins_dis="${plugins_dis} partition federated"
401 plugins="${plugins},innobase"
402 fi 603 fi
604
605 # Upstream specifically requests that InnoDB always be built:
606 # - innobase, innodb_plugin
607 # Build falcon if available for 6.x series.
608 for i in innobase falcon ; do
609 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
610 done
611 for i in innodb_plugin ; do
612 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
613 done
403 614
404 # like configuration=max-no-ndb 615 # like configuration=max-no-ndb
405 if use cluster ; then 616 if use cluster ; then
406 plugins="${plugins},ndbcluster" 617 plugins_sta="${plugins_sta} ndbcluster"
407 myconf="${myconf} --with-ndb-binlog" 618 myconf="${myconf} --with-ndb-binlog"
619 else
620 plugins_dis="${plugins_dis} ndbcluster"
408 fi 621 fi
409 622
410 if mysql_version_is_at_least "5.2" ; then 623 if [[ "${PN}" == "mariadb" ]] ; then
411 plugins="${plugins},falcon" 624 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
625 # caught above.
626 plugins_sta="${plugins_sta},maria,innobase"
627 myconf="${myconf} $(use_with libevent)"
628 # This is not optional, without it several upstream testcases fail.
629 # Also strongly recommended by upstream.
630 myconf="${myconf} --with-maria-tmp-tables"
412 fi 631 fi
632
633 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
634 use pbxt \
635 && plugins_dyn="${plugins_dyn} pbxt" \
636 || plugins_dis="${plugins_dis} pbxt"
637 fi
413 638
639 use static && \
640 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
641 plugins_dyn=""
642
643 einfo "Available plugins: ${plugins_avail}"
644 einfo "Dynamic plugins: ${plugins_dyn}"
645 einfo "Static plugins: ${plugins_sta}"
646 einfo "Disabled plugins: ${plugins_dis}"
647
648 # These are the static plugins
414 myconf="${myconf} --with-plugins=${plugins}" 649 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
650 # And the disabled ones
651 for i in ${plugins_dis} ; do
652 myconf="${myconf} --without-plugin-${i}"
653 done
415} 654}
416 655
417pbxt_src_compile() { 656pbxt_src_configure() {
418 mysql_init_vars 657 mysql_init_vars
419 658
420 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 659 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
421 660
422 einfo "Reconfiguring dir '${PWD}'" 661 einfo "Reconfiguring dir '${PWD}'"
423 AT_GNUCONF_UPDATE="yes" eautoreconf 662 AT_GNUCONF_UPDATE="yes" eautoreconf
424 663
425 local myconf="" 664 local myconf=""
426 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 665 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
427 use debug && myconf="${myconf} --with-debug=full" 666 use debug && myconf="${myconf} --with-debug=full"
428 # TODO: is it safe/needed to use econf here ?
429 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 667 econf ${myconf} || die "Problem configuring PBXT storage engine"
668}
669
670pbxt_src_compile() {
671
672 # Be backwards compatible for now
673 if [[ $EAPI != 2 ]]; then
674 pbxt_src_configure
675 fi
430 # TODO: is it safe/needed to use emake here ? 676 # TODO: is it safe/needed to use emake here ?
431 make || die "Problem making PBXT storage engine (${myconf})" 677 make || die "Problem making PBXT storage engine (${myconf})"
432 678
433 popd 679 popd
434 # TODO: modify test suite for PBXT 680 # TODO: modify test suite for PBXT
435} 681}
436 682
437pbxt_src_install() { 683pbxt_src_install() {
438 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 684 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
439 make install || die "Failed to install PBXT" 685 emake install DESTDIR="${D}" || die "Failed to install PBXT"
440 popd 686 popd
441} 687}
442 688
443# 689#
444# EBUILD FUNCTIONS 690# EBUILD FUNCTIONS
445# 691#
446 692# @FUNCTION: mysql_pkg_setup
693# @DESCRIPTION:
694# Perform some basic tests and tasks during pkg_setup phase:
695# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
696# check for conflicting use flags
697# create new user and group for mysql
698# warn about deprecated features
447mysql_pkg_setup() { 699mysql_pkg_setup() {
448 enewgroup mysql 60 || die "problem adding 'mysql' group" 700 if hasq test ${FEATURES} ; then
449 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 701 if ! use minimal ; then
702 if [[ $UID -eq 0 ]]; then
703 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
704 fi
705 fi
706 fi
450 707
451 # Check for USE flag problems in pkg_setup 708 # Check for USE flag problems in pkg_setup
452 if use static && use ssl ; then 709 if use static && use ssl ; then
453 eerror "MySQL does not support being built statically with SSL support enabled!"
454 die "MySQL does not support being built statically with SSL support enabled!" 710 M="MySQL does not support being built statically with SSL support enabled!"
711 eerror "${M}"
712 die "${M}"
455 fi 713 fi
456 714
457 if ! mysql_version_is_at_least "5.0" \ 715 if ! mysql_version_is_at_least "5.0" \
458 && use raid \ 716 && use raid \
459 && use static ; then 717 && use static ; then
461 eerror "with RAID support enabled." 719 eerror "with RAID support enabled."
462 die "USE flags 'raid' and 'static' conflict!" 720 die "USE flags 'raid' and 'static' conflict!"
463 fi 721 fi
464 722
465 if mysql_version_is_at_least "4.1.3" \ 723 if mysql_version_is_at_least "4.1.3" \
466 && ( use cluster || use extraengine ) \ 724 && ( use cluster || use extraengine || use embedded ) \
467 && use minimal ; then 725 && use minimal ; then
468 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
469 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 726 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
727 eerror "${M}"
728 die "${M}"
470 fi 729 fi
730
731 if mysql_version_is_at_least "5.1" \
732 && xtradb_patch_available \
733 && use xtradb \
734 && use embedded ; then
735 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
736 eerror "${M}"
737 die "${M}"
738 fi
739
740 # Bug #290570, 284946, 307251
741 # Upstream changes made us need a fairly new GCC4.
742 # But only for 5.0.8[3-6]!
743 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
744 GCC_VER=$(gcc-version)
745 case ${GCC_VER} in
746 2*|3*|4.0|4.1|4.2)
747 eerror "Some releases of MySQL required a very new GCC, and then"
748 eerror "later release relaxed that requirement again. Either pick a"
749 eerror "MySQL >=5.0.87, or use a newer GCC."
750 die "Active GCC too old!" ;;
751 esac
752 fi
753
754 # This should come after all of the die statements
755 enewgroup mysql 60 || die "problem adding 'mysql' group"
756 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
471 757
472 mysql_check_version_range "4.0 to 5.0.99.99" \ 758 mysql_check_version_range "4.0 to 5.0.99.99" \
473 && use berkdb \ 759 && use berkdb \
474 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 760 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
475}
476 761
762 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
763 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
764 ewarn "5.1 series should NOT be put into production. In the near"
765 ewarn "future, it will be disabled from building."
766 ewarn ""
767 ewarn "If you need NDB support, you should instead move to the new"
768 ewarn "mysql-cluster package that represents that upstream NDB"
769 ewarn "development."
770 fi
771}
772
773# @FUNCTION: mysql_src_unpack
774# @DESCRIPTION:
775# Unpack the source code and call mysql_src_prepare for EAPI < 2.
477mysql_src_unpack() { 776mysql_src_unpack() {
478 # Initialize the proper variables first 777 # Initialize the proper variables first
479 mysql_init_vars 778 mysql_init_vars
480 779
481 unpack ${A} 780 unpack ${A}
482 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 781 # Grab the patches
483 if mysql_check_version_range "5.1 to 5.1.99" ; then 782 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
484 bitkeeper_fetch "mysql-5.1-ndb" 783
485 elif mysql_check_version_range "5.2 to 5.2.99" ; then
486 bitkeeper_fetch "mysql-5.2-falcon"
487 else
488 bitkeeper_fetch
489 fi
490 cd "${S}"
491 einfo "Running upstream autorun over BK sources ..."
492 BUILD/autorun.sh
493 else
494 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 784 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
785
786 # Be backwards compatible for now
787 case ${EAPI:-0} in
788 2) : ;;
789 0 | 1) mysql_src_prepare ;;
790 esac
791}
792
793# @FUNCTION: mysql_src_prepare
794# @DESCRIPTION:
795# Apply patches to the source code and remove unneeded bundled libs.
796mysql_src_prepare() {
495 cd "${S}" 797 cd "${S}"
496 fi
497 798
498 # Apply the patches for this MySQL version 799 # Apply the patches for this MySQL version
499 EPATCH_SUFFIX="patch" 800 EPATCH_SUFFIX="patch"
500 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory" 801 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
802 # Clean out old items
803 rm -f "${EPATCH_SOURCE}"/*
804 # Now link in right patches
501 mysql_mv_patches 805 mysql_mv_patches
806 # And apply
502 epatch 807 epatch
808
809 # last -fPIC fixup, per bug #305873
810 i="${S}"/storage/innodb_plugin/plug.in
811 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
503 812
504 # Additional checks, remove bundled zlib 813 # Additional checks, remove bundled zlib
505 rm -f "${S}/zlib/"*.[ch] 814 rm -f "${S}/zlib/"*.[ch]
506 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 815 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
507 rm -f "scripts/mysqlbug" 816 rm -f "scripts/mysqlbug"
510 find . -name 'Makefile.am' \ 819 find . -name 'Makefile.am' \
511 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 820 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
512 821
513 if mysql_version_is_at_least "4.1" ; then 822 if mysql_version_is_at_least "4.1" ; then
514 # Remove what needs to be recreated, so we're sure it's actually done 823 # Remove what needs to be recreated, so we're sure it's actually done
824 einfo "Cleaning up old buildscript files"
515 find . -name Makefile \ 825 find . -name Makefile \
516 -o -name Makefile.in \ 826 -o -name Makefile.in \
517 -o -name configure \ 827 -o -name configure \
518 -exec rm -f {} \; 828 -exec rm -f {} \;
519 rm -f "ltmain.sh" 829 rm -f "ltmain.sh"
520 rm -f "scripts/mysqlbug" 830 rm -f "scripts/mysqlbug"
521 fi 831 fi
522 832
523 local rebuilddirlist d 833 local rebuilddirlist d
524 834
835 if xtradb_patch_available && use xtradb ; then
836 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
837 pushd "${S}"/storage >/dev/null
838 i="innobase"
839 o="${WORKDIR}/storage-${i}.mysql-upstream"
840 # Have we been here already?
841 [ -d "${o}" ] && rm -f "${i}"
842 # Or maybe we haven't
843 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
844 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
845 popd >/dev/null
846 fi
847
848 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
849 einfo "Adding storage engine: PBXT"
850 pushd "${S}"/storage >/dev/null
851 i='pbxt'
852 [ -d "${i}" ] && rm -rf "${i}"
853 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
854 popd >/dev/null
855 fi
856
525 if mysql_version_is_at_least "5.1.12" ; then 857 if mysql_version_is_at_least "5.1.12" ; then
526 rebuilddirlist="." 858 rebuilddirlist="."
859 # This does not seem to be needed presently. robbat2 2010/02/23
860 #einfo "Updating innobase cmake"
527 # TODO: check this with a cmake expert 861 ## TODO: check this with a cmake expert
528 use innodb \
529 && cmake \ 862 #cmake \
530 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 863 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
531 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCC)) \ 864 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
532 "storage/innobase" 865 # "storage/innobase"
533 else 866 else
534 rebuilddirlist=". innobase" 867 rebuilddirlist=". innobase"
535 fi 868 fi
536 869
537 for d in ${rebuilddirlist} ; do 870 for d in ${rebuilddirlist} ; do
541 popd &>/dev/null 874 popd &>/dev/null
542 done 875 done
543 876
544 if mysql_check_version_range "4.1 to 5.0.99.99" \ 877 if mysql_check_version_range "4.1 to 5.0.99.99" \
545 && use berkdb ; then 878 && use berkdb ; then
879 einfo "Fixing up berkdb buildsystem"
546 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 880 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
547 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \ 881 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
548 || die "Could not copy libtool.m4 to bdb/dist/" 882 || die "Could not copy libtool.m4 to bdb/dist/"
883 #These files exist only with libtool-2*, and need to be included.
884 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
885 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
886 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
887 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
888 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
889 fi
549 pushd "bdb/dist" &>/dev/null 890 pushd "bdb/dist" &>/dev/null
550 sh s_all \ 891 sh s_all \
551 || die "Failed bdb reconfigure" 892 || die "Failed bdb reconfigure"
552 popd &>/dev/null 893 popd &>/dev/null
553 fi 894 fi
554} 895}
555 896
897# @FUNCTION: mysql_src_configure
898# @DESCRIPTION:
899# Configure mysql to build the code for Gentoo respecting the use flags.
556mysql_src_compile() { 900mysql_src_configure() {
557 # Make sure the vars are correctly initialized 901 # Make sure the vars are correctly initialized
558 mysql_init_vars 902 mysql_init_vars
559 903
560 # $myconf is modified by the configure_* functions 904 # $myconf is modified by the configure_* functions
561 local myconf="" 905 local myconf=""
575 filter-flags "-O" "-O[01]" 919 filter-flags "-O" "-O[01]"
576 920
577 # glib-2.3.2_pre fix, bug #16496 921 # glib-2.3.2_pre fix, bug #16496
578 append-flags "-DHAVE_ERRNO_AS_DEFINE=1" 922 append-flags "-DHAVE_ERRNO_AS_DEFINE=1"
579 923
924 # As discovered by bug #246652, doing a double-level of SSP causes NDB to
925 # fail badly during cluster startup.
926 if [[ $(gcc-major-version) -lt 4 ]]; then
927 filter-flags "-fstack-protector-all"
928 fi
929
580 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing" 930 CXXFLAGS="${CXXFLAGS} -fno-exceptions -fno-strict-aliasing"
581 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti" 931 CXXFLAGS="${CXXFLAGS} -felide-constructors -fno-rtti"
582 mysql_version_is_at_least "5.0" \ 932 mysql_version_is_at_least "5.0" \
583 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 933 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
584 export CXXFLAGS 934 export CXXFLAGS
935
936 # bug #283926, with GCC4.4, this is required to get correct behavior.
937 append-flags -fno-strict-aliasing
585 938
586 econf \ 939 econf \
587 --libexecdir="/usr/sbin" \ 940 --libexecdir="/usr/sbin" \
588 --sysconfdir="${MY_SYSCONFDIR}" \ 941 --sysconfdir="${MY_SYSCONFDIR}" \
589 --localstatedir="${MY_LOCALSTATEDIR}" \ 942 --localstatedir="${MY_LOCALSTATEDIR}" \
600 # TODO: Move this before autoreconf !!! 953 # TODO: Move this before autoreconf !!!
601 find . -type f -name Makefile -print0 \ 954 find . -type f -name Makefile -print0 \
602 | xargs -0 -n100 sed -i \ 955 | xargs -0 -n100 sed -i \
603 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 956 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
604 957
958 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
959 pbxt_patch_available && use pbxt && pbxt_src_configure
960 fi
961}
962
963# @FUNCTION: mysql_src_compile
964# @DESCRIPTION:
965# Compile the mysql code.
966mysql_src_compile() {
967 # Be backwards compatible for now
968 case ${EAPI:-0} in
969 2) : ;;
970 0 | 1) mysql_src_configure ;;
971 esac
972
605 emake || die "emake failed" 973 emake || die "emake failed"
606 974
607 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 975 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
976 pbxt_patch_available && use pbxt && pbxt_src_compile
977 fi
608} 978}
609 979
980# @FUNCTION: mysql_src_install
981# @DESCRIPTION:
982# Install mysql.
610mysql_src_install() { 983mysql_src_install() {
611 # Make sure the vars are correctly initialized 984 # Make sure the vars are correctly initialized
612 mysql_init_vars 985 mysql_init_vars
613 986
614 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 987 emake install \
988 DESTDIR="${D}" \
989 benchdir_root="${MY_SHAREDSTATEDIR}" \
990 testroot="${MY_SHAREDSTATEDIR}" \
991 || die "emake install failed"
615 992
616 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 993 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
617 994 pbxt_patch_available && use pbxt && pbxt_src_install
618 insinto "${MY_INCLUDEDIR}" 995 fi
619 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
620 996
621 # Convenience links 997 # Convenience links
998 einfo "Making Convenience links for mysqlcheck multi-call binary"
622 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 999 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
623 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1000 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
624 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize" 1001 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
625 1002
626 # Various junk (my-*.cnf moved elsewhere) 1003 # Various junk (my-*.cnf moved elsewhere)
1004 einfo "Removing duplicate /usr/share/mysql files"
627 rm -Rf "${D}/usr/share/info" 1005 rm -Rf "${D}/usr/share/info"
628 for removeme in "mysql-log-rotate" mysql.server* \ 1006 for removeme in "mysql-log-rotate" mysql.server* \
629 binary-configure* my-*.cnf mi_test_all* 1007 binary-configure* my-*.cnf mi_test_all*
630 do 1008 do
631 rm -f "${D}"/usr/share/mysql/${removeme} 1009 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
632 done 1010 done
633 1011
634 # Clean up stuff for a minimal build 1012 # Clean up stuff for a minimal build
635 if use minimal ; then 1013 if use minimal ; then
1014 einfo "Remove all extra content for minimal build"
636 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 1015 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
637 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 1016 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
638 rm -f "${D}/usr/sbin/mysqld" 1017 rm -f "${D}/usr/sbin/mysqld"
639 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 1018 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
640 fi 1019 fi
641 1020
1021 # Unless they explicitly specific USE=test, then do not install the
1022 # testsuite. It DOES have a use to be installed, esp. when you want to do a
1023 # validation of your database configuration after tuning it.
1024 if use !test ; then
1025 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1026 fi
1027
642 # Configuration stuff 1028 # Configuration stuff
1029 if mysql_version_is_at_least "5.1" ; then
1030 mysql_mycnf_version="5.1"
643 if mysql_version_is_at_least "4.1" ; then 1031 elif mysql_version_is_at_least "4.1" ; then
644 mysql_mycnf_version="4.1" 1032 mysql_mycnf_version="4.1"
645 else 1033 else
646 mysql_mycnf_version="4.0" 1034 mysql_mycnf_version="4.0"
647 fi 1035 fi
1036 einfo "Building default my.cnf"
648 insinto "${MY_SYSCONFDIR}" 1037 insinto "${MY_SYSCONFDIR}"
649 doins scripts/mysqlaccess.conf 1038 doins scripts/mysqlaccess.conf
650 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1039 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
651 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1040 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
652 > "${TMPDIR}/my.cnf.ok" 1041 > "${TMPDIR}/my.cnf.ok"
653 if mysql_version_is_at_least "4.1" && use latin1 ; then 1042 if mysql_version_is_at_least "4.1" && use latin1 ; then
654 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1043 sed -i \
1044 -e "/character-set/s|utf8|latin1|g" \
1045 "${TMPDIR}/my.cnf.ok"
655 fi 1046 fi
656 newins "${TMPDIR}/my.cnf.ok" my.cnf 1047 newins "${TMPDIR}/my.cnf.ok" my.cnf
657 1048
658 # Minimal builds don't have the MySQL server 1049 # Minimal builds don't have the MySQL server
659 if ! use minimal ; then 1050 if ! use minimal ; then
1051 einfo "Creating initial directories"
660 # Empty directories ... 1052 # Empty directories ...
661 diropts "-m0750" 1053 diropts "-m0750"
662 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 1054 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
663 dodir "${MY_DATADIR}" 1055 dodir "${MY_DATADIR}"
664 keepdir "${MY_DATADIR}" 1056 keepdir "${MY_DATADIR}"
672 chown -R mysql:mysql "${D}/${folder}" 1064 chown -R mysql:mysql "${D}/${folder}"
673 done 1065 done
674 fi 1066 fi
675 1067
676 # Docs 1068 # Docs
1069 einfo "Installing docs"
677 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1070 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
1071 doinfo "${S}"/Docs/mysql.info
1072
1073 # Minimal builds don't have the MySQL server
1074 if ! use minimal ; then
1075 einfo "Including support files and sample configurations"
1076 docinto "support-files"
1077 for script in \
1078 "${S}"/support-files/my-*.cnf \
1079 "${S}"/support-files/magic \
1080 "${S}"/support-files/ndb-config-2-node.ini
1081 do
1082 [[ -f "$script" ]] && dodoc "${script}"
1083 done
1084
1085 docinto "scripts"
1086 for script in "${S}"/scripts/mysql* ; do
1087 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
1088 done
1089
1090 fi
1091
1092 mysql_lib_symlinks "${D}"
1093}
1094
1095# @FUNCTION: mysql_pkg_preinst
1096# @DESCRIPTION:
1097# Create the user and groups for mysql - die if that fails.
1098mysql_pkg_preinst() {
1099 enewgroup mysql 60 || die "problem adding 'mysql' group"
1100 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
1101}
1102
1103# @FUNCTION: mysql_pkg_postinst
1104# @DESCRIPTION:
1105# Run post-installation tasks:
1106# create the dir for logfiles if non-existant
1107# touch the logfiles and secure them
1108# install scripts
1109# issue required steps for optional features
1110# issue deprecation warnings
1111mysql_pkg_postinst() {
1112 # Make sure the vars are correctly initialized
1113 mysql_init_vars
1114
1115 # Check FEATURES="collision-protect" before removing this
1116 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
1117
1118 # Secure the logfiles
1119 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
1120 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
1121 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
678 1122
679 # Minimal builds don't have the MySQL server 1123 # Minimal builds don't have the MySQL server
680 if ! use minimal ; then 1124 if ! use minimal ; then
681 docinto "support-files" 1125 docinto "support-files"
682 for script in \ 1126 for script in \
683 support-files/my-*.cnf \ 1127 support-files/my-*.cnf \
684 support-files/magic \ 1128 support-files/magic \
685 support-files/ndb-config-2-node.ini 1129 support-files/ndb-config-2-node.ini
686 do 1130 do
1131 [[ -f "${script}" ]] \
687 dodoc "${script}" 1132 && dodoc "${script}"
688 done 1133 done
689 1134
690 docinto "scripts" 1135 docinto "scripts"
691 for script in scripts/mysql* ; do 1136 for script in scripts/mysql* ; do
1137 [[ -f "${script}" ]] \
692 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1138 && [[ "${script%.sh}" == "${script}" ]] \
693 done
694 fi
695
696 mysql_lib_symlinks "${D}"
697}
698
699mysql_pkg_preinst() {
700 enewgroup mysql 60 || die "problem adding 'mysql' group"
701 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
702}
703
704mysql_pkg_postinst() {
705 # Make sure the vars are correctly initialized
706 mysql_init_vars
707
708 # Check FEATURES="collision-protect" before removing this
709 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
710
711 # Secure the logfiles
712 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
713 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
714 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
715
716 # Minimal builds don't have the MySQL server
717 if ! use minimal ; then
718 docinto "support-files"
719 for script in \
720 support-files/my-*.cnf \
721 support-files/magic \
722 support-files/ndb-config-2-node.ini
723 do
724 dodoc "${script}" 1139 && dodoc "${script}"
725 done
726
727 docinto "scripts"
728 for script in scripts/mysql* ; do
729 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
730 done 1140 done
731 1141
732 einfo 1142 einfo
733 elog "You might want to run:" 1143 elog "You might want to run:"
734 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1144 elog "\"emerge --config =${CATEGORY}/${PF}\""
735 elog "if this is a new install." 1145 elog "if this is a new install."
736 einfo 1146 einfo
737 fi 1147 fi
738 1148
739 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 1149 if pbxt_available && use pbxt ; then
740 # TODO: explain it better 1150 # TODO: explain it better
741 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1151 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
742 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1152 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
743 elog "if, after that, you cannot start the MySQL server," 1153 elog "if, after that, you cannot start the MySQL server,"
744 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1154 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
754 mysql_check_version_range "4.0 to 5.0.99.99" \ 1164 mysql_check_version_range "4.0 to 5.0.99.99" \
755 && use berkdb \ 1165 && use berkdb \
756 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 1166 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
757} 1167}
758 1168
1169# @FUNCTION: mysql_pkg_config
1170# @DESCRIPTION:
1171# Configure mysql environment.
759mysql_pkg_config() { 1172mysql_pkg_config() {
1173 local old_MY_DATADIR="${MY_DATADIR}"
1174
760 # Make sure the vars are correctly initialized 1175 # Make sure the vars are correctly initialized
761 mysql_init_vars 1176 mysql_init_vars
762 1177
763 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR" 1178 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
764 1179
765 if built_with_use ${CATEGORY}/${PN} minimal ; then 1180 if built_with_use ${CATEGORY}/${PN} minimal ; then
766 die "Minimal builds do NOT include the MySQL server" 1181 die "Minimal builds do NOT include the MySQL server"
767 fi 1182 fi
768 1183
1184 if [[ ( -n "${MY_DATADIR}" ) && ( "${MY_DATADIR}" != "${old_MY_DATADIR}" ) ]]; then
1185 local MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${MY_DATADIR})"
1186 local old_MY_DATADIR_s="$(strip_duplicate_slashes ${ROOT}/${old_MY_DATADIR})"
1187
1188 if [[ -d "${old_MY_DATADIR_s}" ]]; then
1189 if [[ -d "${MY_DATADIR_s}" ]]; then
1190 ewarn "Both ${old_MY_DATADIR_s} and ${MY_DATADIR_s} exist"
1191 ewarn "Attempting to use ${MY_DATADIR_s} and preserving ${old_MY_DATADIR_s}"
1192 else
1193 elog "Moving MY_DATADIR from ${old_MY_DATADIR_s} to ${MY_DATADIR_s}"
1194 mv --strip-trailing-slashes -T "${old_MY_DATADIR_s}" "${MY_DATADIR_s}" \
1195 || die "Moving MY_DATADIR failed"
1196 fi
1197 else
1198 ewarn "Previous MY_DATADIR (${old_MY_DATADIR_s}) does not exist"
1199 if [[ -d "${MY_DATADIR_s}" ]]; then
1200 ewarn "Attempting to use ${MY_DATADIR_s}"
1201 else
1202 eerror "New MY_DATADIR (${MY_DATADIR_s}) does not exist"
1203 die "Configuration Failed! Please reinstall ${CATEGORY}/${PN}"
1204 fi
1205 fi
1206 fi
1207
769 local pwd1="a" 1208 local pwd1="a"
770 local pwd2="b" 1209 local pwd2="b"
1210 local MYSQL_ROOT_PASSWORD=''
771 local maxtry=5 1211 local maxtry=15
1212
1213 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1214 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1215 fi
772 1216
773 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1217 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
774 ewarn "You have already a MySQL database in place." 1218 ewarn "You have already a MySQL database in place."
775 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1219 ewarn "(${ROOT}/${MY_DATADIR}/*)"
776 ewarn "Please rename or delete it if you wish to replace it." 1220 ewarn "Please rename or delete it if you wish to replace it."
777 die "MySQL database already exists!" 1221 die "MySQL database already exists!"
778 fi 1222 fi
779 1223
780 einfo "Creating the mysql database and setting proper" 1224 # Bug #213475 - MySQL _will_ object strenously if your machine is named
781 einfo "permissions on it ..." 1225 # localhost. Also causes weird failures.
1226 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
782 1227
1228 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1229
783 einfo "Insert a password for the mysql 'root' user" 1230 einfo "Please provide a password for the mysql 'root' user now,"
1231 einfo "or in the MYSQL_ROOT_PASSWORD env var."
784 ewarn "Avoid [\"'\\_%] characters in the password" 1232 ewarn "Avoid [\"'\\_%] characters in the password"
785 read -rsp " >" pwd1 ; echo 1233 read -rsp " >" pwd1 ; echo
786 1234
787 einfo "Retype the password" 1235 einfo "Retype the password"
788 read -rsp " >" pwd2 ; echo 1236 read -rsp " >" pwd2 ; echo
789 1237
790 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1238 if [[ "x$pwd1" != "x$pwd2" ]] ; then
791 die "Passwords are not the same" 1239 die "Passwords are not the same"
1240 fi
1241 MYSQL_ROOT_PASSWORD="${pwd1}"
1242 unset pwd1 pwd2
792 fi 1243 fi
793 1244
794 local options="" 1245 local options=""
795 local sqltmp="$(emktemp)" 1246 local sqltmp="$(emktemp)"
796 1247
799 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 1250 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
800 || touch "${TMPDIR}/fill_help_tables.sql" 1251 || touch "${TMPDIR}/fill_help_tables.sql"
801 help_tables="${TMPDIR}/fill_help_tables.sql" 1252 help_tables="${TMPDIR}/fill_help_tables.sql"
802 1253
803 pushd "${TMPDIR}" &>/dev/null 1254 pushd "${TMPDIR}" &>/dev/null
804 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 1255 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
1256 if [ $? -ne 0 ]; then
1257 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
1258 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
1259 fi
805 popd &>/dev/null 1260 popd &>/dev/null
806 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1261 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
807 || die "MySQL databases not installed" 1262 || die "MySQL databases not installed"
808 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2> /dev/null 1263 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
809 chmod 0750 "${ROOT}/${MY_DATADIR}" 2> /dev/null 1264 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
1265
1266 # Figure out which options we need to disable to do the setup
1267 helpfile="${TMPDIR}/mysqld-help"
1268 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1269 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1270 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1271 ; do
1272 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1273 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1274 done
1275 # But some options changed names
1276 egrep -sq external-locking "${helpfile}" && \
1277 options="${options/skip-locking/skip-external-locking}"
810 1278
811 if mysql_version_is_at_least "4.1.3" ; then 1279 if mysql_version_is_at_least "4.1.3" ; then
812 options="--skip-ndbcluster"
813
814 # Filling timezones, see 1280 # Filling timezones, see
815 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1281 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
816 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1282 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
817 1283
818 if [[ -r "${help_tables}" ]] ; then 1284 if [[ -r "${help_tables}" ]] ; then
819 cat "${help_tables}" >> "${sqltmp}" 1285 cat "${help_tables}" >> "${sqltmp}"
820 fi 1286 fi
821 fi 1287 fi
1288
1289 einfo "Creating the mysql database and setting proper"
1290 einfo "permissions on it ..."
822 1291
823 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1292 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
824 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1293 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
825 local mysqld="${ROOT}/usr/sbin/mysqld \ 1294 local mysqld="${ROOT}/usr/sbin/mysqld \
826 ${options} \ 1295 ${options} \
827 --user=mysql \ 1296 --user=mysql \
828 --skip-grant-tables \
829 --basedir=${ROOT}/usr \ 1297 --basedir=${ROOT}/usr \
830 --datadir=${ROOT}/${MY_DATADIR} \ 1298 --datadir=${ROOT}/${MY_DATADIR} \
831 --skip-innodb \
832 --skip-bdb \
833 --skip-networking \
834 --max_allowed_packet=8M \ 1299 --max_allowed_packet=8M \
835 --net_buffer_length=16K \ 1300 --net_buffer_length=16K \
1301 --default-storage-engine=MyISAM \
836 --socket=${socket} \ 1302 --socket=${socket} \
837 --pid-file=${pidfile}" 1303 --pid-file=${pidfile}"
1304 #einfo "About to start mysqld: ${mysqld}"
1305 ebegin "Starting mysqld"
838 ${mysqld} & 1306 ${mysqld} &
1307 rc=$?
839 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1308 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
840 maxtry=$((${maxtry}-1)) 1309 maxtry=$((${maxtry}-1))
841 echo -n "." 1310 echo -n "."
842 sleep 1 1311 sleep 1
843 done 1312 done
1313 eend $rc
844 1314
1315 if ! [[ -S "${socket}" ]]; then
1316 die "Completely failed to start up mysqld with: ${mysqld}"
1317 fi
1318
1319 ebegin "Setting root password"
845 # Do this from memory, as we don't want clear text passwords in temp files 1320 # Do this from memory, as we don't want clear text passwords in temp files
846 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1321 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
847 "${ROOT}/usr/bin/mysql" \ 1322 "${ROOT}/usr/bin/mysql" \
848 --socket=${socket} \ 1323 --socket=${socket} \
849 -hlocalhost \ 1324 -hlocalhost \
850 -e "${sql}" 1325 -e "${sql}"
1326 eend $?
851 1327
852 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1328 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
853
854 "${ROOT}/usr/bin/mysql" \ 1329 "${ROOT}/usr/bin/mysql" \
855 --socket=${socket} \ 1330 --socket=${socket} \
856 -hlocalhost \ 1331 -hlocalhost \
857 -uroot \ 1332 -uroot \
858 -p"${pwd1}" \ 1333 -p"${MYSQL_ROOT_PASSWORD}" \
859 mysql < "${sqltmp}" 1334 mysql < "${sqltmp}"
1335 rc=$?
1336 eend $?
1337 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
860 1338
861 # Stop the server and cleanup 1339 # Stop the server and cleanup
1340 einfo "Stopping the server ..."
862 kill $(< "${pidfile}" ) 1341 kill $(< "${pidfile}" )
863 rm -f "${sqltmp}" 1342 rm -f "${sqltmp}"
864 einfo "Stopping the server ..."
865 wait %1 1343 wait %1
866 einfo "Done" 1344 einfo "Done"
867} 1345}
868 1346
1347# @FUNCTION: mysql_pkg_postrm
1348# @DESCRIPTION:
1349# Remove mysql symlinks.
869mysql_pkg_postrm() { 1350mysql_pkg_postrm() {
870 : # mysql_lib_symlinks "${D}" 1351 : # mysql_lib_symlinks "${D}"
871} 1352}

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.145

  ViewVC Help
Powered by ViewVC 1.1.20